<?php

namespace Test\Feature;

use Feature\Contracts\User;
use Feature\Contracts\World;
use Feature\Feature;

/**
 * Class FeatureTest
 * @package Test\Feature
 */
class FeatureTest extends \PHPUnit_Framework_TestCase
{
    /**
     * @var \PHPUnit_Framework_MockObject_MockObject | World
     */
    private $worldMock;

    /**
     * @var \PHPUnit_Framework_MockObject_MockObject | User
     */
    private $userMock;

    public function setUp()
    {
        parent::setUp(); // TODO: Change the autogenerated stub

        $this->worldMock = $this->getMock(World::class);
        $this->userMock = $this->getMock(User::class);
    }

    public function testEnabledFeature()
    {
        Feature::create($this->worldMock, ['feature' => ['enabled' => 'on']]);

        $this->assertTrue(Feature::isEnabled('feature'));
    }

    public function testEnabledFeatureVariant()
    {
        Feature::clear(); 
        Feature::create($this->worldMock, ['feature' => 'variant']);

        $this->assertTrue(Feature::isEnabled('feature'));
        $this->assertEquals(Feature::variant('feature'), 'variant');
    }
    
    public function testDefaultToOffFeature()
    {
        Feature::clear();
        Feature::create($this->worldMock, []);
        $this->assertFalse(Feature::isEnabled('feature'));
    }
}
